import Environment from '@loafer/core/env/Environment';

export interface ConfigurableEnvironment extends Environment {
	setActiveProfiles(...profiles: string[]): void;
	addActiveProfiles(profile: string): void;
	setDefaultProfiles(...profiles: string[]): void;
  getSystemEnvironment(): Map<string, any>;
  getSystemProperties(): Map<string, any>;
}

export default Environment;
