import {
	ClassType,
	PropertyType,
} from '@loafer/core/constants/types';
import PouchFactory from '@loafer/pouches/factory/PouchFactory';

export interface InjectCapablePouchFactory extends PouchFactory {
	createPouch(type: ClassType, injectMode?: number, dependencyCheck?: boolean): any;
	injectPouch(existingPouch: any): void;
	configureBean(existingBean: any, pouchName: PropertyType): any;
	inject(type: ClassType, injectMode: number, dependencyCheck: boolean): any;
	injectPouchProperties(existingPouch: any, injectMode: number, dependencyCheck: boolean): void;
	applyPouchPropertyValues(existingPouch: any, pouchName: PropertyType): void;
	initializePouch?(existingPouch: any, pouchName: PropertyType): any;
	applyPouchPostProcessorsBeforeInitialization?(existingPouch: any, pouchName: PropertyType): any;
	applyPouchPostProcessorsAfterInitialization?(existingPouch: any, pouchName: PropertyType): any;
	destroyPouch(existingPouch: any): void;
}

export default InjectCapablePouchFactory;
